import os

from ruamel.yaml import YAML

from src.parsers.Telegram.telegram_media_downloader.media_downloader import main, _check_config
from src.parsers.base_parser import BaseParser


class TelegramParser(BaseParser):
    def video_download(self):
        message_id = self.params["link"][self.params["link"].rfind("/") + 1:]
        with open(
                os.path.join(os.path.abspath(""), "src/parsers/Telegram/telegram_media_downloader/config.yaml"),
                mode="r+", encoding="utf-8"
        ) as f:
            config = YAML().load(f.read())
            config["chat"][0]['download_filter'] = f"id >= {message_id} && id < {int(message_id) + 1}"
            config["chat"][0]['last_read_message_id'] = int(message_id)
        with open(
                os.path.join(os.path.abspath(""), "src/parsers/Telegram/telegram_media_downloader/config.yaml"),
                mode="w+", encoding="utf-8"
        ) as f:
            YAML().dump(config, f)
        if _check_config():
            main()
